''Pulse on/off object produces pulses on a given pin with on and off times specified in clock cycles.
''minimum on-time is 14 and off_time is 57 cycles
''
''First assembly example in manual provided inspiraton along with much staring at how mouse.spin works.
''
''Graham Stabler 08/08/06

VAR

long    cog
long    ON_TIME     ' ON_TIME and off time reside in main ram as they are global variables
long    OFF_TIME    ' This allows the pulse cog to access them and for other cogs to alter them via the methods below
long    output_pin  ' A pointer to these variables is passed so be sure to keep them in order and together



PUB start(on,off,o_pin) | i
''  Starts a new cog running as a pulse generator on pin specified by o_pin and with on_time and off_time as specified

ON_TIME := on
OFF_TIME := off
output_pin := |< o_pin                                      'creates a binary number with only bit o_pin set high
cog := cognew(@Toggle, @ON_TIME)                            'Starts cog, passes pointer to globals

PUB ontime(on)
''  Ontime(on_time) sets the on time in clock cycles
ON_TIME := on

PUB offtime(off)
''  Offtime(off_time) sets the off time in clock cycles
OFF_TIME := off

PUB stop
''  Frees the cog and stops the pulse generation       
 if cog
    cogstop(cog~ - 1)    

DAT
                                
                        ORG     0
Toggle                  mov     p,par           'load parameter pointer into p (points to global variables)
                        mov     dira, Pin       'Set pin to output 
                        rdlong  _Delay1,p       'load first parameter into _Delay1
                        add     p,#4            'Increment pointer to next global variable (4 bytes cos its a long)
                        rdlong  _Delay2,p       'Load second parameter (off time)
                        add     p,#4            'Increment pointer to next global variable
                        rdlong  Pin,p           'Load third parameter (pin)                      
                        mov     Time, cnt       'Load system counter into Time                        
                        add     Time, _Delay1   'Set target time for first waitcnt
                        mov     outa, Pin       'Set pin high       
                        'The loop                                 
:loop                   waitcnt Time, _Delay2   'Waiting until Delay1 has passed, add delay2 to target 
                        xor     outa, Pin       'Toggle pin, now in off-time
                        'Get global variables
                        mov     p,par           'load paramter pointer into p
                        mov     dira, Pin       'Set pin to output 
                        rdlong  _Delay1,p       'load first parameter into _Delay1
                        add     p,#4            'Increment pointer to next global variable
                        rdlong  _Delay2,p       'Load second parameter

                        waitcnt Time, _Delay1   'Wait for Delay2 to pass, add delay1 to target for on time
                        xor     outa, Pin       'Toggle pin
                        jmp     #:loop          'Loop

p                       res     1           'Place to put parameter pointer to be manipulated
Time                    res     1           'Target time for waitcnt
_Delay1                 res     1           'This is the on time
_Delay2                 res     1           'This is the off time
Pin                     res     1